const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const subscriptions = sequelize.define(
    'subscriptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"trialing",


"active",


"past_due",


"canceled",


"expired"

        ],

      },

billing_period: {
        type: DataTypes.ENUM,
      
      

        values: [

"yearly"

        ],

      },

price_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

currency: {
        type: DataTypes.TEXT,
      
      

      },

current_period_start: {
        type: DataTypes.DATE,
      
      

      },

current_period_end: {
        type: DataTypes.DATE,
      
      

      },

canceled_at: {
        type: DataTypes.DATE,
      
      

      },

payment_provider: {
        type: DataTypes.TEXT,
      
      

      },

provider_customer_ref: {
        type: DataTypes.TEXT,
      
      

      },

provider_subscription_ref: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subscriptions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity































//end loop



    db.subscriptions.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.subscriptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subscriptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return subscriptions;
};


